"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = connectAsync;

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _shallowequal = _interopRequireDefault(require("shallowequal"));

var _pick = _interopRequireDefault(require("lodash/pick"));

var _values = _interopRequireDefault(require("lodash/values"));

var _mapValues = _interopRequireDefault(require("lodash/mapValues"));

var _reduce = require("./reduce");

var _ssr = require("./ssr");

var _utils = require("./utils");

var _config = _interopRequireDefault(require("./config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function connectAsync(_ref) {
  var loadDataAsProps = _ref.loadDataAsProps,
      localStateChangeLimiter = _ref.stateChangeLimiter,
      localStateChangeComparator = _ref.stateChangeComparator;
  var ssrEnabled = loadDataAsProps.ssr;

  function buildState(_ref2) {
    var store = _ref2.store,
        ownProps = _ref2.ownProps,
        bootstrap = _ref2.bootstrap;
    var propFuncs = loadDataAsProps({
      store: store,
      ownProps: ownProps
    });
    var ssr = (0, _ssr.isSSR)();
    var propResultMap;

    if (ssr && !ssrEnabled) {
      propResultMap = (0, _mapValues.default)(propFuncs, function () {
        return {
          status: 'loading'
        };
      });
    } else {
      propResultMap = (0, _mapValues.default)(propFuncs, function (value) {
        return value({
          ssr: ssr
        });
      });
    }

    var promise = (0, _reduce.reducePromise)(propResultMap);

    if (bootstrap) {
      return promise;
    }
    /*
     * The promise is only used during SSR. During the normal render cycle, it is not as important,
     * as everything is driven by state changes. If the promises are ignored, it could lead to an
     * unhandledrejection event, so we catch here to avoid that.
    */


    (0, _utils.handlePromiseRejection)(promise);
    return {
      data: (0, _reduce.reduceData)(propResultMap),
      status: (0, _reduce.reduceStatus)(propResultMap),
      errors: (0, _reduce.reduceErrors)(propResultMap)
    };
  }

  return function wrapWithConnectAsync(WrappedComponent) {
    var ConnectAsync = /*#__PURE__*/function (_React$Component) {
      _inherits(ConnectAsync, _React$Component);

      var _super = _createSuper(ConnectAsync);

      function ConnectAsync(props, context) {
        var _this;

        _classCallCheck(this, ConnectAsync);

        _this = _super.call(this, props);
        _this.state = buildState({
          store: context.store,
          ownProps: props
        });
        _this.setStateIfNecessary = _this.setStateIfNecessary.bind(_assertThisInitialized(_this));
        _this.onReduxStateChange = _this.onReduxStateChange.bind(_assertThisInitialized(_this));
        _this.isLoading = _this.isLoading.bind(_assertThisInitialized(_this));
        _this.loadedWithErrors = _this.loadedWithErrors.bind(_assertThisInitialized(_this));
        return _this;
      }

      _createClass(ConnectAsync, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this2 = this;

          this.mounted = true;
          var store = this.context.store;
          var globalStateChangeLimiter = _config.default.stateChangeLimiter;
          var stateChangeLimiter = localStateChangeLimiter || globalStateChangeLimiter;
          var onReduxStateChangeLimited = stateChangeLimiter(this.onReduxStateChange);
          this.unsubscribe = store.subscribe(function () {
            return _this2.mounted && onReduxStateChangeLimited();
          });
        }
      }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
          if (!(0, _shallowequal.default)(this.props, nextProps)) {
            this.setStateIfNecessary(buildState({
              store: this.context.store,
              ownProps: nextProps
            }));
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.mounted = false;
          this.unsubscribe();
        }
      }, {
        key: "onReduxStateChange",
        value: function onReduxStateChange() {
          var store = this.context.store;
          var ownProps = this.props;
          this.setStateIfNecessary(buildState({
            store: store,
            ownProps: ownProps
          }));
        }
      }, {
        key: "setStateIfNecessary",
        value: function setStateIfNecessary(newState) {
          var globalStateChangeComparator = _config.default.stateChangeComparator;
          var stateChangeComparator = localStateChangeComparator || globalStateChangeComparator;
          var dataIsEqual = stateChangeComparator(this.state.data, newState.data);
          var statusIsEqual = stateChangeComparator(this.state.status, newState.status);
          var errorsAreEqual = stateChangeComparator(this.state.errors, newState.errors);

          if (!dataIsEqual || !statusIsEqual || !errorsAreEqual) {
            this.setState(newState);
          }
        }
      }, {
        key: "isLoading",
        value: function isLoading(propsOfInterest) {
          var loadStatusMap = this.state.status;
          var statusesOfInterest = (0, _values.default)(propsOfInterest ? (0, _pick.default)(loadStatusMap, propsOfInterest) : loadStatusMap);
          return statusesOfInterest.some(function (status) {
            return status === 'loading';
          });
        }
      }, {
        key: "loadedWithErrors",
        value: function loadedWithErrors(propsOfInterest) {
          var loadErrorMap = this.state.errors;
          var errorsOfInterest = (0, _values.default)(propsOfInterest ? (0, _pick.default)(loadErrorMap, propsOfInterest) : loadErrorMap);
          return errorsOfInterest.some(function (error) {
            return error;
          });
        }
      }, {
        key: "asyncBootstrap",
        value: function asyncBootstrap() {
          if (!ssrEnabled) return false;
          return buildState({
            store: this.context.store,
            ownProps: this.props,
            bootstrap: true
          }).then(function () {
            return true;
          });
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              data = _this$state.data,
              status = _this$state.status,
              errors = _this$state.errors;
          return /*#__PURE__*/_react.default.createElement(WrappedComponent, _extends({}, data, this.props, {
            loadStatus: status,
            isLoading: this.isLoading,
            loadErrors: errors,
            loadedWithErrors: this.loadedWithErrors
          }));
        }
      }]);

      return ConnectAsync;
    }(_react.default.Component);

    ConnectAsync.contextTypes = {
      store: _propTypes.default.shape({
        subscribe: _propTypes.default.func.isRequired,
        dispatch: _propTypes.default.func.isRequired,
        getState: _propTypes.default.func.isRequired
      })
    };
    (0, _hoistNonReactStatics.default)(ConnectAsync, WrappedComponent);
    ConnectAsync.loadDataAsProps = loadDataAsProps;
    ConnectAsync.displayName = "connectAsync(".concat(WrappedComponent.displayName || WrappedComponent.name || 'Component', ")");
    return ConnectAsync;
  };
}